/*
 * @(#)ax88172reg.h	1.2 06/01/24
 * Macro definitions for ASIX AX88172 USB to fast ethernet controler
 * based on ASIX AX88172 data sheet
 * This file is public domain. Coded by M.Murayama (KHF04453@nifty.com)
 */

/*
 * Vendor command definitions
 */
#define	VCMD_READ_SRAM			0x02
#define	VCMD_WRITE_RXSRAM		0x03
#define	VCMD_WRITE_TXSRAM		0x04
#define	VCMD_SOFTWARE_MII_OP		0x06
#define	VCMD_READ_MII_REG		0x07
#define	VCMD_WRITE_MII_REG		0x08
#define	VCMD_READ_MII_OPMODE		0x09
#define	VCMD_HARDWARE_MII_OP		0x0a
#define	VCMD_READ_SROM			0x0b
#define	VCMD_WRITE_SROM			0x0c
#define	VCMD_WRITE_SROM_ENABLE		0x0d
#define	VCMD_WRITE_SROM_DISABLE		0x0e
#define	VCMD_READ_RXCTRL		0x0f
#define	VCMD_WRITE_RXCTRL		0x10
#define	VCMD_READ_IPGS			0x11
#define	VCMD_WRITE_IPG			0x12
#define	VCMD_WRITE_IPG1			0x13
#define	VCMD_WRITE_IPG2			0x14
#define	VCMD_READ_MCAST_FILTER		0x15
#define	VCMD_WRITE_MCAST_FILTER		0x16
#define	VCMD_READ_NODE_ID		0x17
#define	VCMD_READ_PHY_IDS		0x19
#define	VCMD_READ_MEDIUM_STATUS		0x1a
#define	VCMD_WRITE_MEDIUM_STATUS	0x1b
#define	VCMD_SET_MONITOR_MODE		0x1c
#define	VCMD_GET_MONITOR_MODE		0x1d
#define	VCMD_READ_GPIO			0x1e
#define	VCMD_WRITE_GPIO			0x1f

/* ax88772 only,  currently not supported */
#define	VCMD_WRITE_IPGS_88772		0x12
#define	VCMD_READ_NODE_ID_88772		0x13
#define	VCMD_WRITE_NODE_ID_88772	0x14
#define	VCMD_WRITE_TEST_REG_88772	0x17
#define	VCMD_SOFTWARE_RESET_88772	0x20
#define	VCMD_READ_PHY_SELECT_88772	0x21
#define	VCMD_WRITE_PHY_SELECT_88772	0x22


/*
 * Register definitions
 */

/* Rx control register */
#define	RCR_SO		0x80	/* Start Operation */
#define	RCR_AP_88772	0x20	/* accept physical address from mcast filter */
#define	RCR_AM		0x10	/* accept multicast address */
#define	RCR_AB		0x08	/* accept broadcast address */
#define	RCR_SEP		0x04	/* save error packet */
#define	RCR_AMALL	0x02	/* accept all multicast address */
#define	RCR_PRO		0x01	/* promiscious, all frames received */

#define	RCR_BITS	\
	"\020"	\
	"\010SO"	\
	"\006AP"	\
	"\005AM"	\
	"\004AB"	\
	"\003SEP"	\
	"\002AMALL"	\
	"\001PRO"

/* Medium status register */
#define	MSR_FCEN	0x10	/* flow control enable */
#define	MSR_TXABT	0x04	/* Tx abort allow */
#define	MSR_FDPX	0x02	/* full duplex */

#define	MSR_BITS	\
	"\020"	\
	"\005FCEN"	\
	"\003TXABT"	\
	"\002FDPX"

/* GPIO register */
#define	GPIO_DATA2	0x20
#define	GPIO_EN2	0x10
#define	GPIO_DATA1	0x08
#define	GPIO_EN1	0x04
#define	GPIO_DATA0	0x02
#define	GPIO_EN0	0x01

#define	GPIO_BITS	\
	"\020"		\
	"\006DATA2"	\
	"\005EN2"	\
	"\004DATA1"	\
	"\003EN1"	\
	"\002DATA0"	\
	"\001EN0"
